#include <cstdio>
#include <cstring>
using namespace std;

#define ABS(a) ((a)<0?-(a):(a))

int ml, nl, kl;

#define BIGL 15

struct bigint {
	short data[BIGL]; // 10000-ichna broina
	
	bigint() {
		memset(data, 0, sizeof(data));
	}
	bigint(int init) {
		memset(data, 0, sizeof(data));
		data[0] = init;
	}
	
	bigint operator+ (const bigint &a) const {
		bigint res;
		int carry = 0;
		for(int i = 0; i < BIGL; ++i) {
			res.data[i] = data[i]+a.data[i]+carry;
			carry = res.data[i] / 10000;
			res.data[i] %= 10000;
		}
		return res;
	}
	
	bool operator!=(int a) {
		if(data[0] != a) return true;
		for(int i = 1; i < BIGL; ++i) {
			if(data[i] != 0) return true;
		}
		
		return false;
	}
	
	void print() {
		bool printzero = 0;
		for(int i = BIGL-1; i >= 0; --i) {
			if(printzero)
				printf("%04d", data[i]);
			else
				if(data[i] != 0) {
					printzero = 1;
					printf("%d", data[i]);
				}
		}
		printf("\n");
	}
};

bigint mem[128][128][128];
bigint f(int m, int n, int k) {
	if(mem[m][n][k] != -1) return mem[m][n][k];
	
	if(k > kl || k < -kl) return mem[m][n][k] = 0;
	
	if(m > ml || n > nl) return mem[m][n][k] = 0;
	
	if(m == ml && n == nl) return mem[m][n][k] = 1;
	
	return mem[m][n][k] = f(m+1, n, k+1) + f(m, n+1, k-1);
}

int main() {
	for(int i = 0; i < 128; ++i)
		for(int j = 0; j < 128; ++j)
			for(int k = 0; k < 128; ++k)
				mem[i][j][k].data[0] = -1;
	
	scanf("%d%d%d", &ml, &nl, &kl);
	
	f(0, 0, 0).print();
	
	return 0;
}
