#include <iostream>
#include <queue>
using namespace std;

#define MAXN 1024
#define MAXM 10

int n, m;
int fsm[MAXN][MAXM], prev[MAXN], prevc[MAXN];
bool used[MAXN], halt[MAXN];

void printans(int c){
  if(c == 0) return;
  printans(prev[c]);
  cout << prevc[c];     
}

void bfs(){
  int i, c, a;
  for(i = 0; i < n; i++) used[i] = false;
  queue<int> q;
  q.push(0);
  prev[0] = prevc[0] = 0;
  used[0] = true;
  
  while(!q.empty()){
    c = q.front(); q.pop();
    //cout << "c: " << c << endl;
    if(halt[c]){printans(c); cout << endl; return;}
    
    for(a = 1; a <= m; a++)
    if(!used[fsm[c][a]]){
      //cout << "a: " << a << "  F: " << fsm[c][a] << endl;
      used[fsm[c][a]] = true;
      prev[fsm[c][a]] = c;
      prevc[fsm[c][a]] = a;
      q.push(fsm[c][a]);                   
    }
  }
  
  cout << 0 << endl;
  return;
}

int main(){
  int a, i, j, t;
  cin >> n >> m;
  for(i = 0; i < n; i++)
  halt[i] = false;
  for(i = 0; i < n; i++)
  for(a = 1; a <= m; a++)
    cin >> fsm[i][a];
  
  cin >> j;
  for(i = 0; i < j; i++){
    cin >> t;
    halt[t] = true;      
  }
  /*
  for(i = 0; i < n; i++){
    for(a = 1; a <= m; a++)
      cout << fsm[i][a] << ' ';
  cout << endl;
  }
  for(i = 0; i < n; i++)
  cout << halt[i];
  */
  
  bfs();
}
